/*******************************************************************
 * $B%o%$%"%l%9%*%7%m%9%3!<%W(B
 *   PIC24EP256MC202
 * $B!!%3%^%s%I$G2<5-<B9T(B
 *******************************************************************/
#include <xc.h>

/* $B%3%s%U%#%.%e%l!<%7%g%s$N@_Dj(B */
// PIC24EP256MC202 Configuration Bit Settings
// $B30ItH/?64o!J(BEC)$B%b!<%I$G(B48MHz$BF0:n(B
// FICD
#pragma config ICS = PGD1               // ICSP$B%A%c%M%k(B1
#pragma config JTAGEN = OFF             // JTAG$BL58z(B
// FPOR
#pragma config ALTI2C1 = OFF            // I2C1$B%T%sBeBX$($J$7(B
#pragma config ALTI2C2 = OFF            // I2C2$B%T%sBeBX$($J$7(B
#pragma config WDTWIN = WIN25           // WDT$BAk(B 25%
// FWDT
#pragma config WDTPOST = PS32768        // WDT$B%W%j%9%1!<%i(B (1:32,768)
#pragma config WDTPRE = PR128           // WDT$B%W%j%9%1!<%i(B (1:128)
#pragma config PLLKEN = ON              // PLL$B%m%C%/M-8z(B
#pragma config WINDIS = OFF             // WDT$BAk6X;_(B
#pragma config FWDTEN = OFF             // WDT$B6X;_(B
// FOSC
#pragma config POSCMD = EC              // $B<g%/%m%C%/30ItH/?64o(B
#pragma config OSCIOFNC = OFF           // OSC2$B%/%m%C%/=PNO$"$j(B
#pragma config IOL1WAY = OFF            // $B%T%sA*BrM-8z(B
#pragma config FCKSM = CSDCMD           // $B%/%m%C%/4F;k$J$7(B
// FOSCSEL
#pragma config FNOSC = PRIPLL           // $B<gH/?6;HMQ(B
#pragma config PWMLOCK = OFF            // PWM$B%m%C%/L58z(B
#pragma config IESO = OFF               // 2$BB.EY%9%?!<%H%"%C%WL58z(B
// FGS
#pragma config GWRP = OFF               // $B%W%m%F%/%H$J$7(B
#pragma config GCP = OFF                // $B%W%m%F%/%H$J$7(B

/* $B%0%m!<%P%kJQ?t!"Dj?tDj5A(B */
unsigned char Flag, BusyFlag;
int Index;
/* $BAw<u?.%P%C%U%!(B */
#define  Max_Size 4100
__attribute__((far)) unsigned char RcvBuf[64];
__attribute__((far)) unsigned char SndBuf[Max_Size];
/* $B%"%J%m%07WB,%G!<%?3JG<MQ%P%C%U%!(B */
__attribute__((far)) unsigned int Buffer[2000];
/* Bluetooth$B@_DjMQ%3%^%s%I%G!<%?(B */
unsigned char msg1[] = "$$$";                   // $B%3%^%s%I%b!<%I;XDj(B
unsigned char msg2[] = "SF,1\r";                // $B9)>l=P2Y%j%;%C%H(B
unsigned char msg3[] = "SN,Oscilloscope\r";     // $BL>>N@_Dj(B
unsigned char msg4[] = "R,1\r";                 // $B:F5/F0(B
/* $B4X?t%W%m%H%?%$%T%s%0(B */
void Send(unsigned char Data);
void SendData(unsigned char * buf);
void SendCmd(unsigned char *cmd);
void Delayms( unsigned int t);
void Cmnd(unsigned char data);
int  GetADC(int ch);
void SetupOSC(int _period);
void Hsync(unsigned char num);

/*********** $B%a%$%s4X?t(B **************************/
int main(void){
    int i;
    /* $B%/%m%C%/$N@_Dj!!(B48MHz/6=8MHz*30=240/2=120MHz */
    CLKDIVbits.PLLPRE = 4;              // 48MHz/6 = 8MHz
    PLLFBDbits.PLLDIV = 28;             // 8MHz*30 = 240MHz
    CLKDIVbits.PLLPOST = 0;             // 240/2 = 120MHz  Tcy=60MHz
    /* I/O$B$N=i4|@_Dj(B */
    ANSELA = 0x0003;                    // AN0,AN1$B$N$_%"%J%m%0(B
    ANSELB = 0;
    LATB  = 0x0F00;                     // LED Off, TX High     
    TRISA = 0x0007;                     // $B%]!<%H(BA
    TRISB = 0x0323;                     // $B%]!<%H(BB
    /** Bluetooth$B%b%8%e!<%k%j%;%C%H(B */
    LATBbits.LATB15 = 0;                // $B%b%8%e!<%k%j%;%C%H(B
    Delayms(100);                       // $B%Q%k%9I}3NJ](B
    LATBbits.LATB15 = 1;                // $B%j%;%C%H2r=|(B
    Delayms(1000);                      // $B<B9TBT$A(B    
    /* $B%?%$%^#3@_Dj!J(BA/D$BJQ49%H%j%,MQ!K(B */
    PR3 = 59;                           // $B:GB.(B60MHz/60 = 1usec
    T3CON = 0x0000;                     // Off 1:1 Fosc/2   
    /* UART1$B%T%s3dIU(B */
    RPINR18bits.U1RXR = 40;             // UART1 RX to RB8
    RPOR3bits.RP41R = 1;                // UART1 TX to RB9
    /* UART1$B=i4|@_Dj!!(B115kbps  */
    U1MODE = 0x8808;                    // UART1$B=i4|@_Dj(B BRGH=1
    U1STA =  0x0400;                    // UART1$B=i4|@_Dj(B
    U1BRG = 129;                        // 115kbps@60MHz
    IPC2bits.U1RXIP = 4;                // UART1$B3d$j9~$_%l%Y%k(B
    IFS0bits.U1RXIF = 0;                // $B3d$j9~$_%U%i%0%/%j%"(B
    /** Bluetooth$B%b%8%e!<%k=i4|2=(B */    
    if(PORTBbits.RB5 == 0){             // RB5$B$,(BLow$B$N>l9g(B
        SendCmd(msg1);                  // $$$
        SendCmd(msg2);                  // $B9)>l%j%;%C%H(B
        SendCmd(msg3);                  // $BL>>N@_Dj(B
        SendCmd(msg4);                  // $B%j%V!<%H(B
        /** USART $B:F@_Dj(B*/
        U1MODE = 0x8808;                // UART1$B=i4|@_Dj(B BRGH=1
        U1STA =  0x0400;                // UART1$B=i4|@_Dj(B
        U1BRG = 129;                    // 115kbps@60MHz
    }    
    // Setup ADC
    AD1CON1 = 0x8044;                   // AD$B%*%s(B,$B@0?t(B,$B%?%$%^#3$G%H%j%,(B
    AD1CON2 = 0x001E;                   // AVdd, AVss, 8$B2s$4$H3d9~$_(B,$B%P%C%U%!(B2$BJ,3d(B
    AD1CON3 = 0x0003;                   // 0Tad auto-sample, Tad = 4*Tcy= 67usec
    AD1CON4 = 0;                        // DMA Not Use
    AD1CHS123  = 0;                     // AN0$BA*Br(B
    AD1CHS0 = 0;                        // AN0$BA*Br(B
    AD1CSSL = 0;                        // $B<+F0%9%-%c%s$J$7(B
    AD1CSSH = 0;                        // $B<+F0%9%-%c%s$J$7(B
    IPC3bits.AD1IP = 6;                 // $B3d$j9~$_%l%Y%k:G9b0L(B
    IFS0bits.AD1IF = 0;                 // $B3d$j9~$_%U%i%0%/%j%"(B
    /* $BJQ?t=i4|2=(B */ 
    Index = 0;                         // $B=i4|>uBV$K%;%C%H(B
    Flag = 0;
    /*$B3d$j9~$_5v2D(B*/
    IEC0bits.AD1IE = 1;                 // $B3d$j9~$_5v2D(B
    IEC0bits.U1RXIE = 1;                // UART1$B<u?.3d$j9~$_5v2D(B

    /*************** $B%a%$%s%k!<%W(B ********************/
    while(1){
        /* $B<u?.%3%^%s%I=hM}(B */
        if((Flag == 1) && (RcvBuf[0] == 'S')) {
                Flag = 0;                               // $B<u?.40N;%U%i%0%/%j%"(B
                /* $B%G!<%?=hM}(B  */
            switch(RcvBuf[1]){                          // $B<u?.%G!<%?$GJ,4t(B
                /** $B%G!<%?7WB,3+;O%H%j%,(B ***/
                case 'T':
                    /* $B%5%s%W%j%s%0<~4|@_Dj$H%G!<%?Aw?.(B */
                    T3CONbits.TON = 0;                  // $B%?%$%^#3Dd;_(B
                    TMR3 = 0;                           // $B%?%$%^(B3$B%j%;%C%H(B
                    AD1CON1 = 0;                        // AD$B$$$C$?$s%*%U(B
                    Hsync(RcvBuf[2]);                   // $B%5%s%W%k<~4|@_Dj(B
                    Index = 0;                          // $B%P%C%U%!%$%s%G%C%/%9=i4|2=(B
                    if(RcvBuf[3] == 0)                  // $B%A%c%M%k@ZBX(B
                        AD1CHS0 = 0;                    // AN0$B;XDj(B
                    else
                        AD1CHS0 = 1;                    // AN1$B;XDj(B
                    AD1CON1 = 0x8044;                   // AD$B%*%s(B,$B@0?t(B,$B%?%$%^#3$G%H%j%,(B
                    BusyFlag = 1;                       // $B%G!<%?<}=8Cf%U%i%0%*%s(B
                    T3CONbits.TON = 1;                  // $B%?%$%^#33+;O!"%5%s%W%j%s%03+;O(B
                    /*** 2000$B2s%5%s%W%j%s%0=*N;BT$A(B ***/
                    while(BusyFlag == 1);               // $B%G!<%?<}=840N;BT$A(B
                    /* $B<}=840N;!"%G!<%?Aw?.<B9T(B */
                    SndBuf[0] = 0x4D;                   // M$B%;%C%H(B
                    SndBuf[1] = 0x4E;                   // N$B%;%C%H(B
                    for(i=0; i<2000; i++){              // 2000$B8D$N%G!<%?$r%P%$%H$KJQ49(B
                       SndBuf[2*i+2] = Buffer[i] % 256; // $B>e0L%P%$%H(B
                       SndBuf[2*i+3] = Buffer[i] / 256; // $B2<0L%P%$%H(B
                    }
                    SndBuf[4002] = 'E';                 // $B=*N;%^!<%/(B
                    SendData(SndBuf);                   // $BAw?.<B9T(B4100$B%P%$%H(B
                    break;
                default:                                // $B$I$l$G$b$J$$>l9g(B
                    break;
            }
        }
    }
}
/***************************************************
*  A/D$BJQ49%G!<%?<}=83d$j9~$_=hM}4X?t(B
*  8$B2sJQ49$4$H$K3d$j9~$_@8@.!!%@%V%k%P%C%U%!(B
***************************************************/
void __attribute__((interrupt, no_auto_psv)) _AD1Interrupt(void){
    IFS0bits.AD1IF = 0;                     // $B3d$j9~$_%U%i%0%/%j%"(B
    /* $B7WB,%G!<%?$r%P%C%U%!$X3JG<(B 2000$B8D(B */
    if(AD1CON2bits.BUFS == 1){              // $B;HMQCf%P%C%U%!%A%'%C%/(B
        Buffer[Index++] = ADC1BUF0;         // $B2<0L%P%C%U%!$N>l9g(B
        Buffer[Index++] = ADC1BUF1;
        Buffer[Index++] = ADC1BUF2;         // 8$B8D3JG<(B
        Buffer[Index++] = ADC1BUF3;
        Buffer[Index++] = ADC1BUF4;
        Buffer[Index++] = ADC1BUF5;
        Buffer[Index++] = ADC1BUF6;
        Buffer[Index++] = ADC1BUF7;
    }
    else{
        Buffer[Index++] = ADC1BUF8;         // $B>e0L%P%C%U%!$N>l9g(B
        Buffer[Index++] = ADC1BUF9;
        Buffer[Index++] = ADC1BUFA;
        Buffer[Index++] = ADC1BUFB;         // 8$B8D3JG<(B
        Buffer[Index++] = ADC1BUFC;
        Buffer[Index++] = ADC1BUFD;
        Buffer[Index++] = ADC1BUFE;
        Buffer[Index++] = ADC1BUFF;
    }
    if(Index >= 2000){                      // 2000$B2sJQ4940N;$+!)(B
        T3CONbits.TON = 0;                  // $B%?%$%^#3Dd;_(B
        BusyFlag = 0;                       // $BJQ49=*N;BT$A%U%i%02r=|(B
        Index = 0;                          // $B%P%C%U%!%$%s%G%C%/%9=i4|2=(B
    }
}
/***************************************************
* $B?eJ?F14|@Z$jBX$(!!%?%$%^#3$N<~4|JQ99(B
*  PR3 62.5nsec$BC10L$G@_Dj(B
***************************************************/
void Hsync(unsigned char num){
    switch(num){
        case 0:                 // 0.1usec$B"*(B10usec/div
        case 1:                 // 0.2usec$B"*(B20usec/div
        case 2:                 // 1usec$B!!"*(B100us/div
            PR3 = 59;		// 60MHz/60=1usec
            break;
        case 3:
            PR3 = 119;		// 2usec$B!!(B $B"*(B200us/div
            break;
        case 4:
            PR3 = 599;          // 10usec$B!!"*(B1msec/div
            break;
        case 5:
            PR3 = 2999;		// 50usec$B!!"*(B5msec/div
            break;
        default:                // $B$I$l$G$b$J$$>l9gJQ99$J$7(B
            break;
    }
}
/***************************************
*  UART$B<u?.3d$j9~$_=hM}4X?t(B
****************************************/
void __attribute__((interrupt, no_auto_psv))  _U1RXInterrupt(void){
    char  data;

    /* $B<u?.%(%i!<%A%'%C%/(B */
    IFS0bits.U1RXIF = 0;                    // $B3d$j9~$_%U%i%0%/%j%"(B
    if(U1STAbits.OERR || U1STAbits.FERR) {
        data = U1RXREG;;
        U1STA &= 0xFFF0;                    // $B%(%i!<%U%i%0%/%j%"(B
        U1MODE = 0;                         // UART1$BDd;_(B
        U1MODE = 0x8808;                    // UART1$BM-8z2=(B
        Index = 0;
    }
    else {                                  // $B@5>o<u?.$N>l9g(B
        if(Index<64){                       // 64$B%P%$%H0J2<$N>l9g(B
            RcvBuf[Index++] = U1RXREG;      // $B%G!<%?<h$j=P$7(B
            if(Index >= 64){                // 64$B%P%$%H=*N;$+(B
                Flag = 1;                   // $B<u?.40N;%U%i%0%*%s(B
                Index = 0;                  // $B%]%$%s%?%j%;%C%H(B
            }
        }
        else                                // $B%P%C%U%!%*!<%P!<$N>l9g(B
            data = U1RXREG;                 // $BFI$_Ht$P$7$FL5;k(B
    }
}
 /********************************
 * UART $BAw?.<B9T%5%V4X?t(B
 ********************************/
void Send(unsigned char Data){
    while(!U1STAbits.TRMT);              // $BAw?.%l%G%#!<BT$A(B
    U1TXREG = Data;                      // $BAw?.<B9T(B
}
/********************************
 * Bluetooth$BJ8;zNsAw?.4X?t(B
 *******************************/
void SendData(unsigned char * buf)
{
    int i;
    for(i= 0; i<Max_Size; i++)              // 4100$B%P%$%H0l3gAw?.(B
        Send(*buf++);                   // $BAw?.<B9T(B
}
/********************************
 * Bluetooth$B%3%^%s%IAw?.4X?t(B
 * $BCY1dA^F~8eLa$k(B
 ********************************/
void SendCmd(unsigned char *cmd)
{
    while(*cmd != 0)                    // $B=*C<$^$G7+$jJV$7Aw?.(B
        Send(*cmd++);                   // $BAw?.<B9T(B
    Delayms(1000);                      // $BJV?.%9%-%C%WMQCY1d(B
}

/***********************************************
* $B%?%$%^(B2$B$K$h$k(B1msec$BC10L$NCY1d4X?t(B Tcy=60MHz
***********************************************/
void Delayms( unsigned int t){
    IFS0bits.T2IF = 0;                  // $B3d$j9~$_%U%i%0%/%j%"(B
    PR2 = 7500;                         // 1msec$B@_Dj(B
    T2CON = 0x8010;                     // $B%?%$%^(B2$B%9%?!<%H!!(B1/8
    while (t--) {                       // $B7+$jJV$72s?t(B
        while (!IFS0bits.T2IF);         // 1msec$BBT$A(B
        IFS0bits.T2IF = 0;              // $B3d$j9~$_%U%i%0%/%j%"(B
    }
}

